<!-- eslint-disable vue/no-v-html -->
<template>
  <v-card id="wrapper">
    <v-card-title>
      <v-container fluid>
        <v-row>
          <v-col cols="12">
            <v-row>
              <v-col cols="12">
                <v-img
                  v-if="corpusData"
                  class="float-left"
                  height="150" width="150"
                  :src="corpusData.image"
                  :alt="title"
                />
                <dez-placeholder
                  v-else-if="loading" class="float-left"
                  height="150px"
                  width="150px"
                />
                <v-row class="d-flex">
                  <v-col cols="auto" lg="6">
                    {{ title }}
                    <span v-if="corpusData" class="corpus-data-metadata">
                      {{ corpusData.year }}
                    </span>
                    <div v-if="corpusData" class="corpus-data-metadata">
                      {{ corpusData.getMetadata($i18n.locale) }}
                    </div>
                  </v-col>
                  <v-col v-if="corpusData && !loading" style="text-align: right;">
                    <a
                      :href="corpusData.getStatus($i18n.locale)"
                      :title="$t('corpus-table.quality-status')"
                    >
                      <span :class="corpusData.getQualityClass()">{{ corpusData.quality }}</span>
                    </a>
                    <p
                      v-if="corpusData"
                      class="contributors"
                      v-html="corpusData.getContributors()"
                    />
                  </v-col>
                </v-row>
                <v-row>
                  <v-col
                    :cols="corpusData ? 12 : 12"
                    :sm="corpusData ? 11 : 12"
                    :md="corpusData ? 10 : 12"
                    :lg="corpusData ? 9 : 12"
                    :xl="corpusData ? 8 : 12"
                    class="corpus-table-description"
                  >
                    <span
                      v-if="corpusData"
                      v-html="computeMd(corpusData.getText($i18n.locale))"
                    />
                    <dez-placeholder v-else-if="loading" height="50px" width="100%" />
                    <span v-else>
                      {{ description }}
                    </span>
                    <span
                      v-if="corpusData"
                      v-html="computeMd(corpusData.getAvailability($i18n.locale))"
                    />
                    <dez-placeholder v-else-if="loading" height="25px" width="100%" />
                  </v-col>
                </v-row>
                <v-row v-if="corpusData && !loading">
                  <v-col class="py-0">
                    <ref-links dark :refs="corpusData.refs" />
                  </v-col>
                </v-row>
                <v-switch
                  v-if="!corpusData && !loading"
                  v-model="grouped"
                  :label="$t('corpus-table.groupBy')"
                />
              </v-col>
            </v-row>
          </v-col>
        </v-row>
        <v-row justify="end">
          <v-col
            class="py-0"
            cols="12" md="6"
            lg="4"
            xl="3"
          >
            <v-spacer />
            <v-text-field
              v-model="search"
              append-icon="mdi-magnify"
              :label="$t('generic.action.search')"
              single-line
              hide-details
            />
          </v-col>
        </v-row>
      </v-container>
    </v-card-title>
    <v-data-table
      :headers="!corpusData || corpusData.columns === '' ?
        headers :
        customHeaders[corpusData.columns]
      "
      :items="items"
      :single-expand="singleExpand"
      :expanded.sync="expanded"
      :search="search"
      :loading="loading"
      :items-per-page="50"
      :custom-filter="filter"
      item-key="uniqueId"
      :group-by="(grouped && !corpusData) ? 'corpus' : null"
      dense
      :footer-props="{'items-per-page-options':[20, 50, 100, 200]}"
      @item-expanded="fetchAnalyses"
    >
      <template #[`group.header`]="{ items, group, isOpen, toggle }">
        <td colspan="10">
          <v-icon @click="toggle">
            {{ isOpen ? 'mdi-chevron-up' : 'mdi-chevron-down' }}
          </v-icon>
          <router-link
            v-if="items[0].corpusLink"
            class="corpus-link"
            :to="{
              name: 'CorpusTable',
              params: { corpusId: items[0].corpusLink },
            }"
          >
            {{ group }}
          </router-link>
          <span v-else>
            {{ group }}
          </span>
        </td>
      </template>
      <template #[`item.collection`]="{ item }">
        <div class="piece-link-wrapper">
          {{ item.collection }}
        </div>
      </template>
      <template #[`item.title`]="{ item }">
        <div class="piece-link-wrapper">
          <v-tooltip
            v-if="Object.keys(item.opus).length > 0"
            transition="fade-transition"
            right
          >
            <template #activator="{ on, attrs }">
              <v-icon
                class="mr-2" size="16"
                v-bind="attrs"
                v-on="on"
              >
                mdi-information-outline
              </v-icon>
            </template>
            <opus-tooltip :opus="item.opus" />
          </v-tooltip>
          <router-link class="piece-link" :to="getPieceUrl(item)">
            <span>{{ item.title }}</span>
          </router-link>
        </div>
      </template>
      <template #[`item.contributors`]="{ item }">
        <div class="piece-link-wrapper">
          {{ item.contributors }}
        </div>
      </template>
      <template #[`item.opus.opus`]="{ item }">
        <div class="piece-link-wrapper">
          {{ item.opus.opus }}
        </div>
      </template>
      <template #[`item.opus.year`]="{ item }">
        <div class="piece-link-wrapper">
          {{ item.opus.year }}
        </div>
      </template>
      <template #[`item.key`]="{ item }">
        <div class="piece-link-wrapper">
          {{ item.key }}
        </div>
      </template>
      <template #[`item.timeSignature`]="{ item }">
        <div class="piece-link-wrapper">
          {{ item["time-signature"] }}
        </div>
      </template>
      <template #[`item.link`]="{ item }">
        <div class="piece-link-wrapper">
          <ref-links dark :refs="item.refs" />
        </div>
      </template>
      <template #[`item.availableSources`]="{ item }">
        <corpus-table-available-sources :available-sources="item.availableSources" />
      </template>
      <template #expanded-item="{ item }">
        <td v-if="item.analyses.length > 0" colspan="10">
          <tr v-for="analyse in item.analyses" :key="analyse.id" class="analysis-wrapper">
            <div>
              <a :href="`${getPieceUrl(item)}?analysis=${analyse.file}`">
                {{ analyse.file }}
              </a>
            </div>
            <!-- <div class="analysis-actions">
              <v-text-field v-model="textfield" class="mr-4" hint="users to grand access to" />
              <v-btn @click="grant(`${item.id}%2Fanalyses%2F${analyse.file}`)">
              Grant
              </v-btn>
              </div> -->
          </tr>
        </td>
        <td
          v-else colspan="10"
          class="text-center"
        >
          No analysis
        </td>
      </template>
      <template #footer.prepend>
        <div style="display: flex; flex-grow: 1; justify-content:flex-end; padding-right: 15px">
          <v-tooltip top>
            <template #activator="{ on, attrs }">
              <v-btn
                icon
                :disabled="loading"
                x-small
                class="py-4 mr-2"
                right
                v-bind="{...attrs}"
                @click="exportToCSV"
                v-on="on"
              >
                <v-icon>mdi-file-delimited-outline</v-icon>
              </v-btn>
            </template>
            {{ $t('button.export-csv') }}
          </v-tooltip>
          <v-tooltip top>
            <template #activator="{ on, attrs }">
              <v-btn
                icon
                :disabled="loading"
                x-small
                class="py-4"
                right
                v-bind="{...attrs}"
                @click="exportToJSON"
                v-on="on"
              >
                <v-icon>mdi-code-json</v-icon>
              </v-btn>
            </template>
            {{ $t('button.export-json') }}
          </v-tooltip>
        </div>
      </template>
    </v-data-table>
  </v-card>
</template>

<script lang="ts">
import { Component, Prop, Vue } from 'vue-property-decorator';
import axios from 'axios';
import { marked } from 'marked';
import type { Client } from '@/client';
import type { Piece } from '@/data';
import OpusTooltip from '@/components/tooltips/OpusTooltip.vue';
import RefLinks from '@/components/navigation/RefLinks.vue';
import type CorpusData from '@/data/CorpusData';
import DezPlaceholder from '@/vuejs/components/utils/DezPlaceholder.vue';
import CorpusTableAvailableSources from './CorpusTableAvailableSources.vue';

export interface TablePiece {
  contributors: string;
  title: string;
  type: string;
  origin: string;
  id: string;
  time_signature: string;
  link: string;
  analyses: { file: string; id: string }[];
  corpus: string;
  absoluteId: string;
  uniqueId: string;
  key: string;
  'time-signature': string;
  collection: string;
}

const HIDE_COLS_WIDTH_LIMIT = 1200;

@Component({
  components: {
    OpusTooltip,
    RefLinks,
    CorpusTableAvailableSources,
    DezPlaceholder,
  },
})
export default class CorpusTable extends Vue {
  @Prop({ default: null })
  client!: Client;

  @Prop({ required: true })
  title!: string;

  @Prop({ required: false, default: '' })
  description!: string;

  @Prop({ required: true })
  items!: Array<Piece&TablePiece>;

  @Prop({ required: true })
  loading!: boolean;

  @Prop({ required: false, default: null })
  corpusData!: CorpusData;

  @Prop({ default: '~' })
  appName?: string;

  grouped = true;

  // columns headers of the table
  // value = the field of the :items props to link to
  headers = [
    {
      text: this.$t('corpus-table.column.collection'), value: 'collection', fixed: true, width: '15%', align: 'start',
    },
    {
      text: this.$t('corpus-table.column.title'),
      value: 'title',
      groupable: false,
      fixed: true,
      width: '15%',
    },
    {
      text: this.$t('corpus-table.column.contributors'), value: 'contributors', fixed: true, width: '15%',
    },
    {
      text: this.$t('corpus-table.column.opus'), value: 'opus.opus', fixed: true, width: '7%',
    },
    {
      text: this.$t('corpus-table.column.year'), value: 'opus.year', fixed: true, width: '7%', align: ' ',
    },
    {
      text: this.$t('corpus-table.column.key'), value: 'key', fixed: true, width: '8%', align: ' ',
    },
    {
      text: this.$t('corpus-table.column.meter'), value: 'opus.meter', fixed: true, width: '5%', align: ' ',
    },
    {
      text: this.$t('corpus-table.column.availableSources'),
      value: 'availableSources',
      // eslint-disable-next-line @typescript-eslint/no-explicit-any
      sort: (x: any, y: any) => y.sortKey - x.sortKey,
      groupable: false,
      align: ' ',
    },
    {
      text: '', value: 'link', groupable: false, sortable: false, align: ' ', fixed: true, width: '25%',
    },
    // {
    //   text: this.$t('corpus-table.column.corpus'),
    //   value: 'corpus', groupable: true, fixed: true, width: '5%',
    // },
  ];

  customHeaders = {
    ethno: [
      {
        text: this.$t('corpus-table.column.ethno.origin'),
        value: 'origin',
        fixed: true,
        width: '9%',
        align: 'start',
      },
      {
        text: this.$t('corpus-table.column.ethno.type'),
        value: 'type',
        groupable: false,
        fixed: true,
        width: '19%',
      },
      {
        text: this.$t('corpus-table.column.ethno.first-verse'),
        value: 'title',
        groupable: false,
        fixed: true,
        width: '19%',
      },
      {
        text: this.$t('corpus-table.column.ethno.singer'), value: 'opus.contributors.singer', fixed: true, width: '10%',
      },
      {
        text: this.$t('corpus-table.column.ethno.ref'), value: 'opus.opus', fixed: true, width: '7%',
      },
      {
        text: this.$t('corpus-table.column.ethno.year'), value: 'opus.year', fixed: true, width: '5%', align: ' ',
      },
      {
        text: this.$t('corpus-table.column.ethno.pitches'), value: 'opus.key:pcs', fixed: true, width: '12%', align: ' ',
      },
      {
        text: this.$t('corpus-table.column.meter'), value: 'opus.meter', fixed: true, width: '7%', align: ' ',
      },
      {
        text: this.$t('corpus-table.column.ethno.poetic-meter'), value: 'opus.meter:poetic', fixed: true, width: '7%', align: ' ',
      },
      {
        text: this.$t('corpus-table.column.availableSources'),
        value: 'availableSources',
        // eslint-disable-next-line @typescript-eslint/no-explicit-any
        sort: (x: any, y: any) => y.sortKey - x.sortKey,
        groupable: false,
        align: ' ',
      },
      {
        text: '', value: 'link', groupable: false, sortable: false, align: ' ', fixed: true, width: '25%',
      },
    ],
  };

  // rows expanded, no one by default (automatically updated)
  expanded = [];

  // whether it is possible (== false) or not (== true) to expand multiple rows
  singleExpand = true;

  // text input's value to share analysis
  textfield = '';

  // the text input's value for the search bar
  search_value = '';

  timeout: number | null = null;

  formatDataToCSV(): string {
    let csv = 'data:text/csv;charset=utf-8,';

    this.headers.forEach((header, index) => {
      if (header.text) {
        csv += `"${header.text.toString().replaceAll('"', '""')}"`;
      } else {
        csv += `"${header.value.toString().replaceAll('"', '""')}"`;
      }
      csv += index === this.headers.length - 1 ? '\n' : ',';
    });

    this.items.forEach((item) => {
      this.headers.forEach((header, index) => {
        let colValue;
        if (header.value.includes('.')) {
          const splittedHeaderValue = header.value.split('.');
          colValue = item[
            splittedHeaderValue[0] as keyof TablePiece
          // eslint-disable-next-line @typescript-eslint/no-explicit-any
          ][splittedHeaderValue[1] as any];
        } else if (header.value === 'link') {
          let val = '';
          Object.keys(item.refs).forEach((key) => {
            // eslint-disable-next-line @typescript-eslint/no-explicit-any
            val += `${key.replaceAll('"', '')} => ${item.refs[key].replaceAll('"', '')}\r` as any;
          });
          colValue = val;
        } else if (header.value === 'availableSources') {
          let val = '';
          Object.keys(item.availableSources).forEach((key) => {
            // eslint-disable-next-line @typescript-eslint/no-explicit-any
            val += `${key} => ${(item.availableSources as any)[key]}\r` as any;
          });
          colValue = val;
        } else {
          colValue = item[header.value as keyof TablePiece];
        }

        if (!colValue) colValue = '';

        const formattedValue = colValue.toString().replaceAll('"', '""');

        csv += `"${formattedValue}"`;
        csv += index === this.headers.length - 1 ? '\n' : ',';
      });
    });

    return csv;
  }

  generateDownload(data: string, name: string, ext: string) {
    const downloadAnchorNode = document.createElement('a');
    downloadAnchorNode.setAttribute('href', data);
    downloadAnchorNode.setAttribute('download', `${name}.${ext}`);
    document.body.appendChild(downloadAnchorNode);
    downloadAnchorNode.click();
    downloadAnchorNode.remove();
  }

  exportToCSV() {
    const csv = this.formatDataToCSV();
    this.generateDownload(encodeURI(csv).replaceAll('#', '%23'), this.corpusData?.title || 'corpus', 'csv');
  }

  exportToJSON() {
    const json = `data:text/json;charset=utf-8,${encodeURIComponent(JSON.stringify(this.items, null, 2))}`;
    this.generateDownload(json, this.corpusData?.title || 'corpus', 'json');
  }

  get search(): string {
    return this.search_value;
  }

  set search(value: string) {
    if (this.timeout) clearTimeout(this.timeout);
    this.timeout = (setTimeout(() => {
      this.search_value = value;
    }, 300) as unknown as number);
  }

  computeMd(str: string) {
    return marked.parse(str);
  }

  filter(value: string, search: string, item: Piece&TablePiece) {
    const s = search.toLowerCase().trim().split(' ');

    const searchStr = `
      ${item.corpus}
      ${item['time-signature']}
      ${JSON.stringify(item.opus)}
    `.trim().toLowerCase();

    return s.every((sItem: string) => (sItem.startsWith('-')
      ? !searchStr.includes(sItem.slice(1))
      : searchStr.includes(sItem)));
  }

  localLoading: boolean | null = null;

  get isLoading(): boolean {
    return this.loading;
  }

  set isLoading(value: boolean) {
    this.localLoading = value;
  }

  getPieceUrl(e: TablePiece) {
    const path = e.absoluteId.replaceAll('corpus/', '');
    const splitted = path.split('/');
    splitted.pop();
    return `/${this.appName}/${splitted.join('/')}`;
  }

  // builds the HTTP request headers with the client's jwt token
  httpHeaders() {
    return this.client === undefined ? {} : { headers: { Authorization: `Bearer ${this.client.user?.token}` } };
  }

  // loads analyses list of a piece when expanding button is pressed
  // Problems : at the moment the request fails because of the path it is given : e.item.id
  // TODO : store the piece path somewhere
  //            in this.items ? in Piece interface ?
  async fetchAnalyses(e: { item: Piece&TablePiece; value: boolean }) {
    if (e.value) {
      this.isLoading = true;
    }

    try {
      const response = await this.client.get(`${process.env.VUE_APP_CORPUS_URL}${e.item.corpus}/${e.item.id}/analyses`);
      const data = response.data as Array<string>;
      if (e.item.analyses.length === 0) {
        data.forEach((element: string) => {
          if (element !== 'empty.dez') { e.item.analyses.push({ file: element, id: element.toLowerCase() }); }
        });
      }
    } catch (error: unknown) {
      // eslint-disable-next-line no-console
      console.error(error);
    } finally {
      this.isLoading = false;
    }
  }

  // grant read-analysis permission to users input in the textfield
  // Doesn't work because of back bugs, have to fix ResourceAuth and AccessEntries
  async grant(name: string) {
    await axios.put(
      `${process.env.VUE_APP_CORPUS_URL_NEW}/auth/${name}/grant`,
      { users: this.textfield.split(' '), verb: 'read-analysis', action: true },
      this.httpHeaders(),
    )
      // eslint-disable-next-line no-console
      .catch((error) => console.warn(error));
  }

  handleResize(e: Array<ResizeObserverEntry>) {
    if (e[0].contentRect.width < HIDE_COLS_WIDTH_LIMIT) {
      this.headers = [...this.headers.map((item) => (item.align ? { ...item, align: ' d-none' } : { ...item }))];
    } else {
      this.headers = [...this.headers.map((item) => (item.align ? { ...item, align: ' ' } : { ...item }))];
    }
  }

  mounted() {
    const wrapper = document.getElementById('wrapper');
    if (wrapper) {
      new ResizeObserver(this.handleResize).observe(wrapper);
    }
  }
}
</script>

<style scoped lang="scss">
.analysis {
  &-wrapper, &-actions {
    display: flex;
    align-items: baseline;
    justify-content: space-between;
  }
}

.corpus-link {
  color:#666;
}

.corpus-link, .piece-link {
  text-decoration:none;
  font-weight: bold;
}

.piece-link-wrapper {
  max-width: 100%;
  white-space: nowrap;
  overflow: hidden;
  text-overflow: ellipsis;
}

.corpus-link:hover, .piece-link:hover {
  text-decoration:underline;
}

.corpus-table {
  &-description > span {
    word-break: break-word;
    font-size: 14px;
    font-weight: 400;
    line-height: normal;
    margin-top: 10px;
    color: rgba(0,0,0,.6);
  }
}

.corpus-data {
  &-metadata {
    font-weight: normal;
    font-size: 15px;
    color: #444;
  }
}

a .quality
{
  text-decoration: none;
  color: inherit;
}

.qx, .q0, .q1, .q2, .q3, .q4, .q5
{
  font-size: 40%;
  font-weight: bold;
  border-radius: 5px;
  padding: 3px 2px 3px 2px;
  width: 20px;
  height: 20px;
  line-height: 20px;
  display: inline-block;
  text-align: center;
  vertical-align: center;
}

.qx { color: white; background: rgb(240, 240, 240); }
.q0 { color: gray; background: lightslategray; }
.q1 { color: white; background: orangered; }
.q2 { color: gray; background: orange; }
.q3 { color: gray; background: yellow; }
.q4 { color: gray; background: greenyellow; }
.q5 { color: gray; background: greenyellow; }

.contributors {
  color: rgb(230, 230, 230);
  font-size:40%;
  line-height: 2ex;
}
</style>
